Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
HermiteCurve Class Reference

A parametric curve defined by a sequence of control vertices, each with an in and out tangent. More...

`#include "hermiteCurve.h"`

Inheritance diagram for HermiteCurve:

## Public Member Functions
| HermiteCurve (const ParametricCurve &pc)
| Constructs a Hermite from the indicated (possibly non-hermite) curve.
int | append_cv (int type, const LVecBase3 &v)
int | append_cv (int type, PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
| Adds a new CV to the end of the curve.
virtual TypeHandle | force_init_type ()
CubicCurveseg * | get_curveseg (int ti)
const LVecBase3 & | get_cv_in (int n) const
| Returns the in tangent of the given CV.
void | get_cv_in (int n, LVecBase3 &v) const
std::string | get_cv_name (int n) const
| Returns the name of the given CV, or NULL.
const LVecBase3 & | get_cv_out (int n) const
| Returns the out tangent of the given CV.
void | get_cv_out (int n, LVecBase3 &v) const
const LVecBase3 & | get_cv_point (int n) const
| Returns the position of the given CV.
void | get_cv_point (int n, LVecBase3 &v) const
PN_stdfloat | get_cv_tstart (int n) const
| Returns the starting point in parametric space of the given CV.
int | get_cv_type (int n) const
| Returns the given CV's continuity type, HC_CUT, HC_FREE, HC_G1, or HC_SMOOTH, or 0 if there is no such CV.
int | get_num_cvs () const
| Returns the number of CV's in the curve.
virtual TypeHandle | get_type () const
int | insert_cv (PN_stdfloat t)
| Inserts a new CV at the given parametric point along the curve.
virtual void | output (std::ostream &out) const
virtual bool | rebuild_curveseg (int rtype0, PN_stdfloat t0, const LVecBase4 &v0, int rtype1, PN_stdfloat t1, const LVecBase4 &v1, int rtype2, PN_stdfloat t2, const LVecBase4 &v2, int rtype3, PN_stdfloat t3, const LVecBase4 &v3)
| Rebuilds the current curve segment (as selected by the most recent call to find_curve()) according to the specified properties (see CubicCurveseg::compute_seg).
void | remove_all_cvs ()
| Removes all CV's from the curve.
bool | remove_cv (int n)
| Removes the given CV from the curve.
bool | set_cv_in (int n, const LVecBase3 &v)
bool | set_cv_in (int n, PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
| Changes the given CV's in tangent.
bool | set_cv_name (int n, const char *name)
| Changes the name associated with a particular CV.
bool | set_cv_out (int n, const LVecBase3 &v)
bool | set_cv_out (int n, PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
| Changes the given CV's out tangent.
bool | set_cv_point (int n, const LVecBase3 &v)
bool | set_cv_point (int n, PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
| Changes the given CV's position.
bool | set_cv_tstart (int n, PN_stdfloat tstart)
| Changes the given CV's parametric starting time.
bool | set_cv_type (int n, int type)
| Changes the given CV's continuity type.
void | write_cv (std::ostream &out, int n) const
Public Member Functions inherited from PiecewiseCurve
virtual bool | adjust_point (PN_stdfloat t, PN_stdfloat px, PN_stdfloat py, PN_stdfloat pz)
| Recomputes the curve such that it passes through the point (px, py, pz) at time t, but keeps the same tangent value at that point.
virtual bool | adjust_pt (PN_stdfloat t, PN_stdfloat px, PN_stdfloat py, PN_stdfloat pz, PN_stdfloat tx, PN_stdfloat ty, PN_stdfloat tz)
| Recomputes the curve such that it passes through the point (px, py, pz) with the tangent (tx, ty, tz).
virtual bool | adjust_tangent (PN_stdfloat t, PN_stdfloat tx, PN_stdfloat ty, PN_stdfloat tz)
| Recomputes the curve such that it has the tangent (tx, ty, tz) at time t, but keeps the same position at the point.
virtual bool | get_2ndtangent (PN_stdfloat t, LVecBase3 &tangent2) const
| Returns the tangent of the first derivative of the curve at the point t.
virtual bool | get_bezier_segs (BezierSegs &bz_segs) const
| Fills up the indicated vector with a list of BezierSeg structs that describe the curve.
ParametricCurve * | get_curveseg (int ti)
| Returns the curve segment corresponding to the given index.
virtual PN_stdfloat | get_max_t () const
| Returns the upper bound of t for the entire curve.
int | get_num_segs () const
| Returns the number of curve segments that make up the Piecewise curve.
virtual bool | get_point (PN_stdfloat t, LVecBase3 &point) const
| Returns the point of the curve at a given parametric point t.
virtual bool | get_pt (PN_stdfloat t, LVecBase3 &point, LVecBase3 &tangent) const
| Simultaneously returns the point and tangent of the curve at a given parametric point t.
virtual bool | get_tangent (PN_stdfloat t, LVecBase3 &tangent) const
| Returns the tangent of the curve at a given parametric point t.
PN_stdfloat | get_tend (int ti) const
| Returns the parametric end of the given segment of the curve.
PN_stdfloat | get_tlength (int ti) const
| Returns the parametric length of the given segment of the curve.
PN_stdfloat | get_tstart (int ti) const
| Returns the parametric start of the given segment of the curve.
bool | insert_curveseg (int ti, ParametricCurve *seg, PN_stdfloat tlength)
| Inserts a new curve segment at the indicated index.
virtual bool | is_valid () const
| Returns true if the curve is defined.
void | make_nurbs (int order, int num_cvs, const PN_stdfloat knots[], const LVecBase4 cvs[])
| Defines the curve as a general NURBS curve.
void | remove_all_curvesegs ()
| Removes all curve segments from the curve.
bool | remove_curveseg (int ti)
| Removes the given curve segment from the curve and frees it.
bool | set_tlength (int ti, PN_stdfloat tlength)
| Sets the parametric length of the given segment of the curve.
Public Member Functions inherited from ParametricCurve
| ParametricCurve ()
| This is a virtual base class.
PN_stdfloat | calc_length () const
| Approximates the length of the entire curve to within a few decimal places.
PN_stdfloat | calc_length (PN_stdfloat from, PN_stdfloat to) const
| Approximates the length of the curve segment from parametric time 'from' to time 'to'.
virtual bool | convert_to_hermite (HermiteCurve *hc) const
| Stores an equivalent curve representation in the indicated Hermite curve, if possible.
virtual bool | convert_to_nurbs (ParametricCurve *nc) const
| Stores in the indicated NurbsCurve a NURBS representation of an equivalent curve.
PN_stdfloat | find_length (PN_stdfloat start_t, PN_stdfloat length_offset) const
| Returns the parametric value corresponding to the indicated distance along the curve from the starting parametric value.
virtual bool | get_bezier_seg (BezierSeg &) const
| Fills the BezierSeg structure with a description of the curve segment as a Bezier, if possible, but does not change the _t member of the structure.
int | get_curve_type () const
| Returns the flag indicating the use to which the curve is intended to be put.
int | get_num_dimensions () const
| Returns the number of significant dimensions in the curve's vertices, as set by a previous call to set_num_dimensions().
virtual NurbsCurveInterface * | get_nurbs_interface ()
| Returns a pointer to the object as a NurbsCurveInterface object if it happens to be a NURBS-style curve; otherwise, returns NULL.
virtual bool | recompute ()
| Recalculates the curve, if necessary.
void | register_drawer (ParametricCurveDrawer *drawer)
| Registers a Drawer with this curve that will automatically be updated whenever the curve is modified, so that the visible representation of the curve is kept up to date.
virtual bool | safe_to_flatten () const
| Returns true if it is generally safe to flatten out this particular kind of PandaNode by duplicating instances, false otherwise (for instance, a Camera cannot be safely flattened, because the Camera pointer itself is meaningful).
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of PandaNode by calling the xform() method, false otherwise.
void | set_curve_type (int type)
| Sets the flag indicating the use to which the curve is intended to be put.
void | set_num_dimensions (int num)
| Specifies the number of significant dimensions in the curve's vertices.
virtual bool | stitch (const ParametricCurve *a, const ParametricCurve *b)
| Regenerates this curve as one long curve: the first curve connected end-to- end with the second one.
void | unregister_drawer (ParametricCurveDrawer *drawer)
| Removes a previously registered drawer from the list of automatically- refreshed drawers.
bool | write_egg (Filename filename, CoordinateSystem cs=CS_default)
| Writes an egg description of the nurbs curve to the specified output file.
bool | write_egg (std::ostream &out, const Filename &filename, CoordinateSystem cs)
| Writes an egg description of the nurbs curve to the specified output stream.
Public Member Functions inherited from PandaNode
| PandaNode (const std::string &name)
void | add_child (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node.
virtual void | add_for_draw (CullTraverser *trav, CullTraverserData &data)
| Adds the node's contents to the CullResult we are building up during the cull traversal, so that it will be drawn at render time.
void | add_stashed (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node, directly as a stashed child.
void | adjust_draw_mask (DrawMask show_mask, DrawMask hide_mask, DrawMask clear_mask)
| Adjusts the hide/show bits of this particular node.
virtual void | apply_attribs_to_vertices (const AccumulatedAttribs &attribs, int attrib_types, GeomTransformer &transformer)
| Applies whatever attributes are specified in the AccumulatedAttribs object (and by the attrib_types bitmask) to the vertices on this node, if appropriate.
virtual Light * | as_light ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.
virtual ConstPointerTo< TransformState > | calc_tight_bounds (LPoint3 &min_point, LPoint3 &max_point, bool &found_any, const TransformState *transform, Thread *current_thread=Thread::get_current_thread()) const
| This is used to support NodePath::calc_tight_bounds().
void | clear_attrib (int slot)
| Removes the render attribute of the given type from this node.
void | clear_attrib (TypeHandle type)
void | clear_bounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.
void | clear_effect (TypeHandle type)
| Removes the render effect of the given type from this node.
void | clear_effects (Thread *current_thread=Thread::get_current_thread())
void | clear_state (Thread *current_thread=Thread::get_current_thread())
void | clear_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread())
void | clear_transform (Thread *current_thread=Thread::get_current_thread())
void | clear_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.
virtual PandaNode * | combine_with (PandaNode *other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.
int | compare_tags (const PandaNode *other) const
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.
void | copy_all_properties (PandaNode *other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.
void | copy_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Makes another instance of all the children of the other node, copying them to this node.
PointerTo< PandaNode > | copy_subgraph (Thread *current_thread=Thread::get_current_thread()) const
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
void | copy_tags (PandaNode *other)
| Copies all of the tags stored on the other node onto this node.
int | count_num_descendants () const
| Returns the number of nodes at and below this level.
virtual bool | cull_callback (CullTraverser *trav, CullTraverserData &data)
| This function will be called during the cull traversal to perform any additional operations that should be performed at cull time.
virtual PandaNode * | dupe_for_flatten () const
| This is similar to make_copy(), but it makes a copy for the specific purpose of flatten.
int | find_child (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | find_parent (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | find_stashed (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
ConstPointerTo< RenderAttrib > | get_attrib (int slot) const
ConstPointerTo< RenderAttrib > | get_attrib (TypeHandle type) const
ConstPointerTo< BoundingVolume > | get_bounds (Thread *current_thread=Thread::get_current_thread()) const
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
ConstPointerTo< BoundingVolume > | get_bounds (UpdateSeq &seq, Thread *current_thread=Thread::get_current_thread()) const
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundingVolume::BoundsType | get_bounds_type () const
PandaNode * | get_child (int n, Thread *current_thread=Thread::get_current_thread()) const
int | get_child_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
Children | get_children (Thread *current_thread=Thread::get_current_thread()) const
DrawMask | get_draw_control_mask () const
DrawMask | get_draw_show_mask () const
ConstPointerTo< RenderEffect > | get_effect (TypeHandle type) const
ConstPointerTo< RenderEffects > | get_effects (Thread *current_thread=Thread::get_current_thread()) const
int | get_fancy_bits (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
virtual int | get_first_visible_child () const
| Returns the index number of the first visible child of this node, or a number >= get_num_children() if there are no visible children of this node.
ConstPointerTo< BoundingVolume > | get_internal_bounds (Thread *current_thread=Thread::get_current_thread()) const
int | get_internal_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_into_collide_mask () const
virtual CollideMask | get_legal_collide_mask () const
int | get_nested_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_net_collide_mask (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.
DrawMask | get_net_draw_control_mask () const
| Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.
DrawMask | get_net_draw_show_mask () const
| Returns the union of all draw_show_mask values–of renderable nodes only– at this level and below.
virtual int | get_next_visible_child (int n) const
| Returns the index number of the next visible child of this node following the indicated child, or a number >= get_num_children() if there are no more visible children of this node.
int | get_num_children (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_parents (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_stashed (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_tags () const
ConstPointerTo< RenderAttrib > | get_off_clip_planes (Thread *current_thread=Thread::get_current_thread()) const
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
PandaNode * | get_parent (int n, Thread *current_thread=Thread::get_current_thread()) const
Parents | get_parents (Thread *current_thread=Thread::get_current_thread()) const
ConstPointerTo< TransformState > | get_prev_transform (Thread *current_thread=Thread::get_current_thread()) const
PandaNode * | get_stashed (int n, Thread *current_thread=Thread::get_current_thread()) const
Stashed | get_stashed (Thread *current_thread=Thread::get_current_thread()) const
int | get_stashed_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
ConstPointerTo< RenderState > | get_state (Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag_key (size_t i) const
void | get_tag_keys (vector_string &keys) const
| Fills the given vector up with the list of tags on this PandaNode.
ConstPointerTo< TransformState > | get_transform (Thread *current_thread=Thread::get_current_thread()) const
unsigned int | get_unexpected_change (unsigned int flags) const
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.
virtual int | get_unsafe_to_apply_attribs () const
| Returns the union of all attributes from SceneGraphReducer::AttribTypes that may not safely be applied to the vertices of this node.
virtual int | get_visible_child () const
| Returns the index number of the currently visible child of this node.
bool | has_attrib (int slot) const
bool | has_attrib (TypeHandle type) const
bool | has_dirty_prev_transform () const
bool | has_effect (TypeHandle type) const
virtual bool | has_selective_visibility () const
| Should be overridden by derived classes to return true if this kind of node has some restrictions on the set of children that should be rendered.
virtual bool | has_single_child_visibility () const
| Should be overridden by derived classes to return true if this kind of node has the special property that just one of its children is visible at any given time, and furthermore that the particular visible child can be determined without reference to any external information (such as a camera).
bool | has_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
bool | has_tags () const
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.
bool | is_bounds_stale () const
virtual bool | is_collision_node () const
| A simple downcast check.
bool | is_final (Thread *current_thread=Thread::get_current_thread()) const
virtual bool | is_geom_node () const
| A simple downcast check.
virtual bool | is_lod_node () const
| A simple downcast check.
bool | is_overall_hidden () const
virtual bool | is_renderable () const
| Returns true if there is some value to visiting this particular node during the cull traversal for any camera, false otherwise.
bool | is_scene_root () const
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.
bool | is_under_scene_root () const
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.
void | list_tags (std::ostream &out, const std::string &separator="\n") const
| Writes a list of all the tag keys assigned to the node to the indicated stream.
void | ls (std::ostream &out, int indent_level) const
virtual PandaNode * | make_copy () const
| Returns a newly-allocated PandaNode that is a shallow copy of this one.
void | mark_bounds_stale (Thread *current_thread=Thread::get_current_thread()) const
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
void | mark_internal_bounds_stale (Thread *current_thread=Thread::get_current_thread())
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
void | prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state)
| Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.
virtual bool | preserve_name () const
| Returns true if the node's name has extrinsic meaning and must be preserved across a flatten operation, false otherwise.
virtual void | r_prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state, GeomTransformer &transformer, Thread *current_thread)
| The recursive implementation of prepare_scene().
void | remove_all_children (Thread *current_thread=Thread::get_current_thread())
| Removes all the children from the node at once, including stashed children.
void | remove_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth child from the node.
bool | remove_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Removes the indicated child from the node.
void | remove_stashed (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth stashed child from the node.
bool | replace_child (PandaNode *orig_child, PandaNode *new_child, Thread *current_thread=Thread::get_current_thread())
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
void | replace_node (PandaNode *other)
| Inserts this node into the scene graph in place of the other one, and removes the other node.
void | reset_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Resets the transform that represents this node's "previous" position to the same as the current transform.
virtual bool | safe_to_combine () const
| Returns true if it is generally safe to combine this particular kind of PandaNode with other kinds of PandaNodes of compatible type, adding children or whatever.
virtual bool | safe_to_combine_children () const
| Returns true if it is generally safe to combine the children of this PandaNode with each other.
virtual bool | safe_to_flatten_below () const
| Returns true if a flatten operation may safely continue past this node, or false if nodes below this node may not be molested.
virtual bool | safe_to_modify_transform () const
| Returns true if it is safe to automatically adjust the transform on this kind of node.
void | set_attrib (const RenderAttrib *attrib, int override=0)
| Adds the indicated render attribute to the scene graph on this node.
void | set_bound (const BoundingVolume *volume)
void | set_bounds (const BoundingVolume *volume)
| Resets the bounding volume so that it is the indicated volume.
void | set_bounds_type (BoundingVolume::BoundsType bounds_type)
void | set_effect (const RenderEffect *effect)
| Adds the indicated render effect to the scene graph on this node.
void | set_effects (const RenderEffects *effects, Thread *current_thread=Thread::get_current_thread())
void | set_final (bool flag)
void | set_into_collide_mask (CollideMask mask)
void | set_overall_hidden (bool overall_hidden)
void | set_prev_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
void | set_state (const RenderState *state, Thread *current_thread=Thread::get_current_thread())
void | set_tag (const std::string &key, const std::string &value, Thread *current_thread=Thread::get_current_thread())
void | set_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
void | set_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.
void | stash_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
bool | stash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
void | steal_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Moves all the children from the other node onto this node.
void | unstash_child (int stashed_index, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
bool | unstash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write (std::ostream &out, int indent_level) const
void | write_recorder (BamWriter *manager, Datagram &dg)
| This method is provided for the benefit of classes (like MouseRecorder) that inherit from PandaMode and also RecorderBase.
virtual void | xform (const LMatrix4 &mat)
| Transforms the contents of this PandaNode by the indicated matrix, if it means anything to do so.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Initializes the factory for reading these things from Bam files.
Static Public Member Functions inherited from PiecewiseCurve
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from ParametricCurve
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PandaNode
static PointerTo< PandaNode > | decode_from_bam_stream (vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on those bytes.
static DrawMask | get_all_camera_mask ()
static TypeHandle | get_class_type ()
static DrawMask | get_overall_bit ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type PandaNode.
static void | reset_all_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Visits all nodes in the world with the _dirty_prev_transform flag–that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0–and resets the _prev_transform to be the same as _transform.
static void | set_scene_root_func (SceneRootFunc *func)
| This is used by the GraphicsEngine to hook in a pointer to the scene_root_func(), the function to determine whether the node is an active scene root.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from ParametricCurve
typedef pvector< BezierSeg > | BezierSegs
Public Types inherited from PandaNode
enum | FancyBits { FB_transform = 0x0001 , FB_state = 0x0002 , FB_effects = 0x0004 , FB_tag = 0x0010 , FB_draw_mask = 0x0020 , FB_cull_callback = 0x0040 }
typedef bool | SceneRootFunc(const PandaNode *)
enum | UnexpectedChange { UC_parents = 0x001 , UC_children = 0x002 , UC_transform = 0x004 , UC_state = 0x008 , UC_draw_mask = 0x010 }
Public Attributes inherited from PandaNode
| clear_tag
| Removes the value defined for this key on this particular node.
| get_all_camera_mask
| Returns a DrawMask that is appropriate for rendering to all cameras.
| get_bounds_type
| Returns the bounding volume type set with set_bounds_type().
| get_child
| Returns the nth child node of this node.
| get_children
| Returns an object that can be used to walk through the list of children of the node.
| get_draw_control_mask
| Returns the set of bits in draw_show_mask that are considered meaningful.
| get_draw_show_mask
| Returns the hide/show bits of this particular node.
| get_effects
| get_internal_bounds
| Returns the node's internal bounding volume.
| get_internal_vertices
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
| get_into_collide_mask
| Returns the "into" collide mask for this node.
| get_legal_collide_mask
| Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.
| get_nested_vertices
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
| get_num_children
| Returns the number of child nodes this node has.
| get_num_parents
| Returns the number of parent nodes this node has.
| get_num_stashed
| Returns the number of stashed nodes this node has.
| get_num_tags
| get_overall_bit
| get_parent
| Returns the nth parent node of this node.
| get_parents
| Returns an object that can be used to walk through the list of parents of the node, similar to get_children() and get_stashed().
| get_prev_transform
| get_python_tags
| get_stashed
| Returns the nth stashed child of this node.
| get_state
| get_tag
| get_tag_key
| get_transform
| has_tag
| is_bounds_stale
| is_final
| Returns the current state of the "final" flag.
| is_overall_hidden
| Returns true if the node has been hidden to all cameras by clearing its overall bit.
| set_bounds_type
| Specifies the desired type of bounding volume that will be created for this node.
| set_effects
| Sets the complete RenderEffects that will be applied this node.
| set_final
| set_into_collide_mask
| Sets the "into" CollideMask.
| set_overall_hidden
| Sets or clears the hidden flag.
| set_state
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| set_tag
| Associates a user-defined value with a user-defined key which is stored on the node.
| set_transform
| Sets the transform that will be applied to this node and below.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A parametric curve defined by a sequence of control vertices, each with an in and out tangent.

This class is actually implemented as a PiecewiseCurve made up of several CubicCurvesegs, each of which is created using the hermite_basis() method. The HermiteCurve class itself keeps its own list of the CV's that are used to define the curve (since the CubicCurveseg class doesn't retain these).

Definition at line 83 of file hermiteCurve.h.

## Constructor & Destructor Documentation

## ◆ HermiteCurve() [1/2]

HermiteCurve::HermiteCurve | ( |  | ) |

Definition at line 240 of file hermiteCurve.cxx.

## ◆ HermiteCurve() [2/2]

HermiteCurve::HermiteCurve | ( | const ParametricCurve & | pc | ) |

Constructs a Hermite from the indicated (possibly non-hermite) curve.

Definition at line 247 of file hermiteCurve.cxx.

References ParametricCurve::ParametricCurve(), and ParametricCurve::convert_to_hermite().

## ◆ ~HermiteCurve()

HermiteCurve::~HermiteCurve | ( |  | ) |
| virtual

Definition at line 260 of file hermiteCurve.cxx.

## Member Function Documentation

## ◆ append_cv() [1/2]

int HermiteCurve::append_cv | ( | int | type,
|  | const LVecBase3 & | v )
| inline

Definition at line 93 of file hermiteCurve.h.

## ◆ append_cv() [2/2]

int HermiteCurve::append_cv | ( | int | type,
|  | PN_stdfloat | x,
|  | PN_stdfloat | y,
|  | PN_stdfloat | z )

Adds a new CV to the end of the curve.

The new CV is given initial in/out tangents of 0. The return value is the index of the new CV.

Definition at line 324 of file hermiteCurve.cxx.

References PiecewiseCurve::insert_curveseg(), HermiteCurveCV::set_in(), HermiteCurveCV::set_out(), and HermiteCurveCV::set_type().

Referenced by ParametricCurve::convert_to_hermite(), and insert_cv().

## ◆ force_init_type()

virtual TypeHandle HermiteCurve::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from PiecewiseCurve.

Definition at line 173 of file hermiteCurve.h.

## ◆ get_class_type()

static TypeHandle HermiteCurve::get_class_type | ( |  | ) |
| inline static

Definition at line 162 of file hermiteCurve.h.

## ◆ get_curveseg()

CubicCurveseg * HermiteCurve::get_curveseg | ( | int | ti | ) |
| inline

Definition at line 132 of file hermiteCurve.h.

## ◆ get_cv_in() [1/2]

const LVecBase3 & HermiteCurve::get_cv_in | ( | int | n | ) | const

Returns the in tangent of the given CV.

Definition at line 517 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ get_cv_in() [2/2]

void HermiteCurve::get_cv_in | ( | int | n,
|  | LVecBase3 & | v ) const

Definition at line 525 of file hermiteCurve.cxx.

## ◆ get_cv_name()

string HermiteCurve::get_cv_name | ( | int | n | ) | const

Returns the name of the given CV, or NULL.

Definition at line 565 of file hermiteCurve.cxx.

## ◆ get_cv_out() [1/2]

const LVecBase3 & HermiteCurve::get_cv_out | ( | int | n | ) | const

Returns the out tangent of the given CV.

Definition at line 534 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ get_cv_out() [2/2]

void HermiteCurve::get_cv_out | ( | int | n,
|  | LVecBase3 & | v ) const

Definition at line 542 of file hermiteCurve.cxx.

## ◆ get_cv_point() [1/2]

const LVecBase3 & HermiteCurve::get_cv_point | ( | int | n | ) | const

Returns the position of the given CV.

Definition at line 500 of file hermiteCurve.cxx.

## ◆ get_cv_point() [2/2]

void HermiteCurve::get_cv_point | ( | int | n,
|  | LVecBase3 & | v ) const

Definition at line 508 of file hermiteCurve.cxx.

## ◆ get_cv_tstart()

PN_stdfloat HermiteCurve::get_cv_tstart | ( | int | n | ) | const

Returns the starting point in parametric space of the given CV.

Definition at line 551 of file hermiteCurve.cxx.

References PiecewiseCurve::get_max_t(), and PiecewiseCurve::get_tstart().

Referenced by insert_cv(), and set_cv_tstart().

## ◆ get_cv_type()

int HermiteCurve::get_cv_type | ( | int | n | ) | const

Returns the given CV's continuity type, HC_CUT, HC_FREE, HC_G1, or HC_SMOOTH, or 0 if there is no such CV.

Definition at line 487 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ get_num_cvs()

int HermiteCurve::get_num_cvs | ( |  | ) | const

Returns the number of CV's in the curve.

Definition at line 272 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite(), and insert_cv().

## ◆ get_type()

virtual TypeHandle HermiteCurve::get_type | ( |  | ) | const
| inline virtual

Reimplemented from PiecewiseCurve.

Definition at line 170 of file hermiteCurve.h.

## ◆ init_type()

static void HermiteCurve::init_type | ( |  | ) |
| inline static

Definition at line 165 of file hermiteCurve.h.

## ◆ insert_cv()

int HermiteCurve::insert_cv | ( | PN_stdfloat | t | ) |

Inserts a new CV at the given parametric point along the curve.

If this parametric point is already on the curve, the CV is assigned an index between its two neighbors and the indices of all following CV's are incremented by 1; its in and out tangents are chosen to keep the curve consistent. If the new parametric point is beyond the end of the existing curve, the curve is extended to meet it and the new CV's position, in tangent, and out tangent are set to zero.

The index number of the new CV is returned.

Definition at line 289 of file hermiteCurve.cxx.

References append_cv(), get_cv_tstart(), PiecewiseCurve::get_max_t(), get_num_cvs(), PiecewiseCurve::get_pt(), PiecewiseCurve::insert_curveseg(), PiecewiseCurve::is_valid(), and set_cv_tstart().

## ◆ output()

void HermiteCurve::output | ( | std::ostream & | out | ) | const
| virtual

Reimplemented from PandaNode.

Definition at line 578 of file hermiteCurve.cxx.

## ◆ rebuild_curveseg()

bool HermiteCurve::rebuild_curveseg | ( | int | rtype0,
|  | PN_stdfloat | t0,
|  | const LVecBase4 & | v0,
|  | int | rtype1,
|  | PN_stdfloat | t1,
|  | const LVecBase4 & | v1,
|  | int | rtype2,
|  | PN_stdfloat | t2,
|  | const LVecBase4 & | v2,
|  | int | rtype3,
|  | PN_stdfloat | t3,
|  | const LVecBase4 & | v3 )
| virtual

Rebuilds the current curve segment (as selected by the most recent call to find_curve()) according to the specified properties (see CubicCurveseg::compute_seg).

Returns true if possible, false if something goes horribly wrong.

Reimplemented from PiecewiseCurve.

Definition at line 649 of file hermiteCurve.cxx.

## ◆ register_with_read_factory()

void HermiteCurve::register_with_read_factory | ( |  | ) |
| static

Initializes the factory for reading these things from Bam files.

Definition at line 818 of file hermiteCurve.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

## ◆ remove_all_cvs()

void HermiteCurve::remove_all_cvs | ( |  | ) |

Removes all CV's from the curve.

Definition at line 369 of file hermiteCurve.cxx.

References PiecewiseCurve::remove_all_curvesegs().

Referenced by ParametricCurve::convert_to_hermite().

## ◆ remove_cv()

bool HermiteCurve::remove_cv | ( | int | n | ) |

Removes the given CV from the curve.

Returns true if the CV existed, false otherwise.

Definition at line 349 of file hermiteCurve.cxx.

References PiecewiseCurve::remove_curveseg().

## ◆ set_cv_in() [1/2]

bool HermiteCurve::set_cv_in | ( | int | n,
|  | const LVecBase3 & | v )
| inline

Definition at line 106 of file hermiteCurve.h.

## ◆ set_cv_in() [2/2]

bool HermiteCurve::set_cv_in | ( | int | n,
|  | PN_stdfloat | x,
|  | PN_stdfloat | y,
|  | PN_stdfloat | z )

Changes the given CV's in tangent.

Depending on the continuity type, this may also adjust the out tangent.

Definition at line 427 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ set_cv_name()

bool HermiteCurve::set_cv_name | ( | int | n,
|  | const char * | name )

Changes the name associated with a particular CV.

Definition at line 472 of file hermiteCurve.cxx.

## ◆ set_cv_out() [1/2]

bool HermiteCurve::set_cv_out | ( | int | n,
|  | const LVecBase3 & | v )
| inline

Definition at line 110 of file hermiteCurve.h.

## ◆ set_cv_out() [2/2]

bool HermiteCurve::set_cv_out | ( | int | n,
|  | PN_stdfloat | x,
|  | PN_stdfloat | y,
|  | PN_stdfloat | z )

Changes the given CV's out tangent.

Depending on the continuity type, this may also adjust the in tangent.

Definition at line 441 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ set_cv_point() [1/2]

bool HermiteCurve::set_cv_point | ( | int | n,
|  | const LVecBase3 & | v )
| inline

Definition at line 102 of file hermiteCurve.h.

## ◆ set_cv_point() [2/2]

bool HermiteCurve::set_cv_point | ( | int | n,
|  | PN_stdfloat | x,
|  | PN_stdfloat | y,
|  | PN_stdfloat | z )

Changes the given CV's position.

Definition at line 413 of file hermiteCurve.cxx.

## ◆ set_cv_tstart()

bool HermiteCurve::set_cv_tstart | ( | int | n,
|  | PN_stdfloat | tstart )

Changes the given CV's parametric starting time.

This may affect the shape of the curve.

Definition at line 455 of file hermiteCurve.cxx.

References get_cv_tstart(), PiecewiseCurve::get_tstart(), and PiecewiseCurve::set_tlength().

Referenced by ParametricCurve::convert_to_hermite(), and insert_cv().

## ◆ set_cv_type()

bool HermiteCurve::set_cv_type | ( | int | n,
|  | int | type )

Changes the given CV's continuity type.

Legal values are HC_CUT, HC_FREE, HC_G1, or HC_SMOOTH.

Other than HC_CUT, these have no effect on the actual curve; it remains up to user software to impose the constraints these imply.

HC_CUT implies a disconnection of the curve; HC_FREE imposes no constraints on the tangents; HC_G1 forces the tangents to be collinear, and HC_SMOOTH forces the tangents to be identical. Setting type type to HC_G1 or HC_SMOOTH may adjust the out tangent to match the in tangent.

Definition at line 392 of file hermiteCurve.cxx.

Referenced by ParametricCurve::convert_to_hermite().

## ◆ write_cv()

void HermiteCurve::write_cv | ( | std::ostream & | out,
|  | int | n ) const

Definition at line 606 of file hermiteCurve.cxx.

The documentation for this class was generated from the following files:

- panda/src/parametrics/hermiteCurve.h
- panda/src/parametrics/hermiteCurve.cxx